﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Net;
using System.Net.Sockets;
using System.Threading;


namespace Asynchronous2
{
    public partial class Form1 : Form
    {
        static String gReadText = "";
        static String gSendText = "";
        static Boolean fGo = false;//実行フラグ

        static Socket listener1;//Start
        static Socket listener2;//AcceptCallback
        static Socket handler2;//AcceptCallback
        static StateObject state3;//ReadCallback
        static Socket handler3;//ReadCallback
        static Socket handler4;//SendCallback


        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            button1.Enabled = true;
            button2.Enabled = false;
        }

        private void Form1_FormClosed(object sender, FormClosedEventArgs e)
        {

        }

        private void button1_Click(object sender, EventArgs e)
        {
            IPHostEntry ipHostInfo = Dns.Resolve(Dns.GetHostName());
            IPAddress ipAddress = ipHostInfo.AddressList[0];
            IPEndPoint localEndPoint = new IPEndPoint(ipAddress, 13000);
            listener1 = new Socket(AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.Tcp);

            try
            {
                listener1.Bind(localEndPoint);
                listener1.Listen(100);
                fGo = true;//ロープ実行
                button1.Enabled = false;
                button2.Enabled = true;
                textBox3.AppendText("WiFi connected\r\n");
            }
            catch (Exception ex) { ;}
        }

        private void button2_Click(object sender, EventArgs e)
        {
            gSendText = gSendText + textBox2.Text + "\r\n";
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            if (fGo == true)
            {
                listener1.BeginAccept(new AsyncCallback(AcceptCallback),listener1);
                fGo = false;//実行停止
                textBox3.AppendText(gReadText);// textBox3にテキスト追加
                gReadText = "";
            }

        }

        public static void AcceptCallback(IAsyncResult ar)
        {
            // Get the socket that handles the client request.
            listener2= (Socket)ar.AsyncState;
            handler2= listener2.EndAccept(ar);

            // Create the state object.
            StateObject state = new StateObject();
            state.workSocket = handler2;
            handler2.BeginReceive(state.buffer, 0, StateObject.BufferSize, 0,new AsyncCallback(ReadCallback), state);
        }

        public static void ReadCallback(IAsyncResult ar)
        {
            String content = String.Empty;

            // Retrieve the state object and the handler socket
            // from the asynchronous state object.
            state3 = (StateObject)ar.AsyncState;
            handler3 = state3.workSocket;

            // Read data from the client socket. 
            int bytesRead = handler3.EndReceive(ar);

            if (bytesRead > 0)
            {
                // There  might be more data, so store the data received so far.
                state3.sb.Append(Encoding.ASCII.GetString(state3.buffer, 0, bytesRead));
                content = state3.sb.ToString();
                if (content.IndexOf("\n") > -1)
                {
                    gReadText = content;
                }
                else
                {
                    //gReadText = content;
                }
                Send(handler3, gSendText);
                gSendText = "";
                fGo = true;
            }
        }

        private static void Send(Socket handler3, String data)
        {
            // Convert the string data to byte data using ASCII encoding.
            byte[] byteData = Encoding.ASCII.GetBytes(data);

            // Begin sending the data to the remote device.
           handler3.BeginSend(byteData, 0, byteData.Length, 0,new AsyncCallback(SendCallback), handler3);
        }

        private static void SendCallback(IAsyncResult ar)
        {
            try
            {
                // Retrieve the socket from the state object.
                handler4 = (Socket)ar.AsyncState;

                // Complete sending the data to the remote device.
                int bytesSent = handler4.EndSend(ar);
                //Console.WriteLine("Sent {0} bytes to client.", bytesSent);

                handler4.Shutdown(SocketShutdown.Both);
                handler4.Close();

            }
            catch (Exception ex)
            {
                //Console.WriteLine(e.ToString());
            }
            
        }





    }

    // State object for reading client data asynchronously
    public class StateObject
    {
        // Client  socket.
        public Socket workSocket = null;
        // Size of receive buffer.
        public const int BufferSize = 1024;
        // Receive buffer.
        public byte[] buffer = new byte[BufferSize];
        // Received data string.
        public StringBuilder sb = new StringBuilder();
    }

}
